class BachetSpieler {
	public int liefereZahl(int aktZahl) {
		return IO.readInt("1 <= zahl <= 10 eingeben:");
	}
}

class BachetProgramm extends BachetSpieler {
	public int liefereZahl(int aktZahl) {
		int zahl = 12 - aktZahl % 11;
		if (zahl > 10) {
			return 1;
		} else {
			return zahl;
		}
	}
}

class UE18Aufgabe13 {
	// Hauptprogramm
	public static void main(String[] args) {
		BachetSpieler spielerA = new BachetSpieler();
		BachetSpieler spielerB = new BachetProgramm();
		int startzahl = (int) (Math.random() * 30);
		BachetSpiel spiel = new BachetSpiel(spielerA, spielerB, startzahl);
		spiel.go();
	}
}

class BachetSpiel {

	// Attribute
	BachetSpieler spielerA, spielerB, aktSpieler;
	int zahl;

	public BachetSpiel(BachetSpieler spielerA, BachetSpieler spielerB, int zahl) {
		this.spielerA = spielerA;
		this.spielerB = spielerB;
		this.aktSpieler = spielerA;
		this.zahl = zahl;
	}

	public void go() {
		IO.println("Spieler A ist an der Reihe");
		while (this.zahl < 100) {
			IO.println("Zahl: " + this.zahl);
			int spielerZahl = this.aktSpieler.liefereZahl(this.zahl);
			if (spielerZahl < 1 || spielerZahl > 10) {
				IO.println("Verloren: ungueltige Zahl!");
				return;
			}
			this.zahl += spielerZahl;
			if (this.zahl < 100) {
				if (this.aktSpieler == spielerA) {
					this.aktSpieler = spielerB;
					IO.println("Spieler B ist an der Reihe");
				} else {
					this.aktSpieler = spielerA;
					IO.println("Spieler A ist an der Reihe");
				}
			}
		}
		IO.println("Zahl: " + this.zahl);
		if (this.aktSpieler == spielerA)
			IO.println("Spieler A hat gewonnen!");
		else
			IO.println("Spieler B hat gewonnen!");
	}
}
