
class PersonX {
	private String vorname;
	private String nachname;

	PersonX(String vorname, String nachname) {
		this.vorname = vorname;
		this.nachname = nachname;
	}

	void gruessen(PersonX person) {
		System.out.println(this.getName() + " gruesst " + person.getName());
	}

	String getName() {
		return this.vorname + " " + this.nachname;
	}
}

class Akademiker extends PersonX {
	private String titel;

	Akademiker(String vorname, String nachname) {
		super(vorname, nachname);
		this.titel = null;
	}

	Akademiker(String vorname, String nachname, String titel) {
		super(vorname, nachname);
		this.titel = titel;
	}

	@Override
	String getName() {
		if (this.titel == null) {
			return super.getName();
		}
		return this.titel + " " + super.getName();
	}

}

public class UE18Aufgabe19 {

	public static void main(String[] args) {
		PersonX otto = new PersonX("Otto", "Mueller");
		PersonX karl = new Akademiker("Karl", "Schmidt");
		PersonX maria = new Akademiker("Maria", "Meier", "Dr.");
		otto.gruessen(karl);
		karl.gruessen(maria);
		maria.gruessen(otto);
	}

}
